import 'dart:convert';

import 'package:http/http.dart';
import 'package:test_sa/models/new_models/traf_customer.dart';
import 'package:test_sa/providers/loading_list_notifier.dart';

import '../../controllers/api_routes/api_manager.dart';
import '../../controllers/api_routes/urls.dart';

class CustomerLookupProvider extends LoadingListNotifier<TrafCustomer> {
  @override
  Future getData({int? id}) async {}

  Future getDataByUserId(String? userId) async {
    if (loading == true) return -2;
    if (userId == null || userId.isEmpty) return -1;

    loading = true;
    notifyListeners();
    try {
      Response response = await ApiManager.instance.get(URLs.getCustomersByUserId + "?userId=$userId", useCache: true, enableToastMessage: false);
      stateCode = response.statusCode;
      if (response.statusCode >= 200 && response.statusCode < 300) {
        List categoriesListJson = json.decode(response.body)["data"];
        items = categoriesListJson.map((item) => TrafCustomer.fromJson(item)).toList();
      }
      loading = false;
      notifyListeners();
      return response.statusCode;
    } catch (error) {
      loading = false;
      stateCode = -1;
      notifyListeners();
      return -1;
    }
  }
}
